﻿#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <mmsystem.h>
#include <windows.h>
#include <vfw.h>
#include <commctrl.h>
#include <stdio.h>
#include <assert.h>
#include <tchar.h>
#include <shlwapi.h>
#include <windowsx.h>
#include <time.h>
#include <locale.h>

#pragma comment( lib, "shlwapi.lib" )
#pragma comment(lib,"msvfw32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib, "comctl32.lib")


#define TEMP_FILE_NAME                     L"soundfile.mp3"
#define LOG_FILE_NAME                      L"soundplayer.log"                            

#define TEXT_BUTTON_PAUSE                  L"▮▮"                
#define TEXT_BUTTON_PLAY                   L"▶"


typedef struct tagID3V2HEADER
{
	char        tag[3];
	char        version[2];
	char        flags;
	char       size[4]; //syncface
} ID3V2HEADER;

typedef struct tagInternalData
{
	//現在再生しているデータに関するもの
	DWORD maxSrc;
	MCI_OPEN_PARMS open;
	MCI_PLAY_PARMS play;
	BOOL  Status;        //現在再生しているかどうか
	BOOL IsTrackFoucs;   //トラックバーがフォーカスを持っているか

	int NowPlay;         //現在再生してるファイルのアドレス
	int MaxPlay;         //減殺再生しているファイル軍の総数

	WCHAR *ParentDir;    //親ディレクトリ
	WCHAR **File;        //これから再生するファイル名

	//トラックバーコントロール
	HWND hTrack;
	//ボタンコントロール
	HWND hButton;
	//エディト
	HWND hEdit;

}InternalData;

//
//MCIを使い、サウンドファイルを読み込む
//lpFilePath...読み込ませたいファイル名
//lpstrDeviceType...そのファイルのタイプ(今のところはmp3のみを考える)
//rettemp...作成された構造体の情報
//callflag...読み込み失敗時に、create_temp_fileを呼び出すかどうか
//
//return TRUE...成功 / FALSE...失敗
//
int InitSoundStruct(LPCWSTR lpFilePath, LPCWSTR lpstrDeviceType, InternalData *retTemp, int callflag = TRUE);

//
//ID3タグがあるとき、それがない状態のmp3を作成する
//lpFilePath...ID3タグがあるかもしれないファイルパス
//lpstrDeviceType...そのファイルのタイプ(今のところはmp3のみを考える)
//rettemp...作成された構造体の情報
//
//return TRUE...成功 / FALSE...失敗
//
int create_temp_file(LPCWSTR lpFilePath, LPCWSTR lpstrDeviceType, InternalData *retTemp);

//
//トラックバーの作成
//hWnd...メインウィンドウのハンドル
//
//return 作成されたトラックバーのハンドル (失敗時はNULL)
//
HWND CreateTrackbar(HWND hWnd);

//
//トラックバーに関する設定を行う
//indata...設定されるべきトラックバーのハンドル
//
void SetTrackbarStatus(InternalData indata);

//
//ウィンドウのカスタムドローを一括して行う
//hWnd...メインウィンドウのハンドル
//indata...アプリが一括して管理するデータの構造体
//wp,lp...ウィンドウプロシージャから受け取った値
//
//return 様々な値
//
LRESULT CustomDrawProc(HWND hWnd, InternalData indata, WPARAM wp, LPARAM lp);

//
//音声を再生する
//indata...変更されるべきデータを持った構造体
//
//return 常にTRUE
//
int StartPlaySound(InternalData *indata);

//
//OutputDebugStringの改造版
//(lpOutputString,...)...出力される文字列
//
//return 成功...TRUE / 失敗...FALSE
//
int OutputDebugStringEx(LPCWSTR lpOutputString, ...);

//
//Userに開かれるべきファイルを訪ねる
//hWnd...親ウィンドのハンドル
//temp...情報を受け取ることができる構造体
//
//return TRUE...成功 /FALSE...失敗
//
int GetFileNames(HWND hWnd, InternalData *temp);

//
//作成されたファイルパスデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData_indata(InternalData *indata);

//
//作成されたMCIデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData_MCI(InternalData *indata);

//
//作成されたファイルパス、MCIデータといったデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData(InternalData *indata);

//
//作成したtempを削除
//
void deletetemp(void);

//
//ボタンを作成
//hWnd...メインウィンドウのハンドル
//
//return 作成されたボタンのハンドル / 失敗時：NULL
//
HWND CreateButton(HWND hWnd);

//
//エディトを作成
//hWnd...メインウィンドウのハンドル
//
//return 作成されたボタンのハンドル / 失敗時：NULL
//
HWND CreateShowSecondArea(HWND hWnd);

//
//Logを出力する
//(lpOutputString,...)...出力される文字列
//
//return 成功...TRUE / 失敗...FALSE
//
int OutputExeLog(LPCWSTR lpOutputString, ...);